;From utkcs2!emory!wuarchive!usc!apple!agate!ucbvax!tut.cis.ohio-state.edu!unreplyable!garbage Mon Apr  8 09:13:24 1991
;Article: 235 of gnu.emacs.sources
;Path: utkcs2!emory!wuarchive!usc!apple!agate!ucbvax!tut.cis.ohio-state.edu!unreplyable!garbage
;From: hallvard@IFI.UIO.NO (Hallvard B Furuseth)
;Newsgroups: gnu.emacs.sources
;Subject: load-library
;Message-ID: <9104051416.AA14321@holmenkollen.ifi.uio.no>
;Date: 5 Apr 91 14:16:05 GMT
;Sender: daemon@tut.cis.ohio-state.edu
;Distribution: gnu
;Organization: Source only  Discussion and requests in gnu.emacs.help.
;Lines: 165
;
;Next version of load-library, merged with Graham Gough's version.  See
;comment at the top.
;Also included find-library (similar to find-file),
;where-is-file (in PATH, locate FILE with one of SUFFIXES),
;and funcall-with-message (display a message in the echo area, do a
;funcall, delete the message)
;
;I'm reinventing the wheel with the two last functions, but they seem
;to only be available in C code.  I hope FSF will make the C versions
;available as subr's, that should be more effective than this.
;
;
;			Hallvard
;
;
;
;
;
;
;
;
;; Load-library with completion - version 2.2, 28-03-91
;; Created by Hallvard Furuseth (hallvard@ifi.uio.no).
;; Merged with Graham Gough (graham@cs.man.ac.uk)'s version with a cached
;;   obarray of completions.  To re-read the completion list, give a
;;   prefix arg.
;; If you use a partial-completion package, you must replace its checks
;;   like (eq TABLE 'read-file-name-internal)
;;   with (memq TABLE '(read-file-name-internal library-complete)).

(defun load-library (library)
  "Load the library named LIBRARY.
With prefix arg, first reset the cached array of files in load-path.
This is an interface to the function `load'."
  (interactive (progn
		 (if current-prefix-arg (setq load-completions nil))
		 (list (completing-read "Load Library: " 'library-complete))))
  (load library))

(defun find-library (library)
  "Edit the library named LIBRARY.  Also looks for compressed source.
With prefix arg, first reset the cached array of files in load-path."
  (interactive (progn
		 (if current-prefix-arg (setq load-completions nil))
		 (list (completing-read "Find Library: " 'library-complete))))
  (let ((file (where-is-file load-path library ".el:.el.Z:.elc:")))
    (if file
	(find-file file)
      (message "Library %s not found" library)
      nil)))


(defvar load-completions nil
  "(load-path . ((dir . file-obarray) ...)) used by find-library/load-library")

(defun library-complete (lib pred-unused all)
  "Search load-path for LIBRARY.  Returns competion list if 3rd arg ALL is t,
otherwise completion of LIBRARY (t if complete, nil if no completions).
2nd arg is unused."
  (let* ((subdir (file-name-directory lib)) ; nil if no directory
	 (match (file-name-nondirectory lib))
	 (table (if (equal (car load-completions) load-path)
		    (cdr (assoc subdir (cdr load-completions)))
		  (setq load-completions (list (copy-sequence load-path)))
		  nil)))
    (or table
	(funcall-with-message "(Building load-completions...)"
	  (function
	   (lambda ()
	     (let ((fl (apply 'nconc
			      (mapcar
			       (function 
				(lambda (l) 
				  (cond (subdir
					 (setq l (expand-file-name subdir l)))
					((null l)
					 (setq l default-directory)))
				  (if (file-directory-p l)
				      (directory-files l nil "\\.elc?$"))))
			       load-path))))
	       (if fl
		   (progn
		     (setq table (make-vector (if subdir 31 127) 0))
		     (while fl
		       (intern
			(substring (car fl) 0 (string-match ".elc?$" (car fl)))
			table)
		       (setq fl (cdr fl)))
		     (nconc load-completions (list (cons subdir table))))))))))
    (cond ((null table)
	   nil)
	  (all
	   (all-completions match table))
	  ((and (stringp (setq match (try-completion match table)))
		subdir)
	   (expand-file-name match subdir))
	  (match))))


(defun funcall-with-message (fWm-msg fWm-fun &rest fWm-args)
  (if (eq (selected-window) (minibuffer-window))
      (save-excursion
	(goto-char (point-max))
	(let ((fWm-pmax (point-max)))
	  (unwind-protect
	      (progn
		(insert " " fWm-msg)
		(goto-char fWm-pmax)
		(sit-for 0)		; Redisplay - is there no cleaner way?
		(apply fWm-fun fWm-args))
	    (delete-region fWm-pmax (point-max)))))
    (prog2
	(message "%s" fWm-msg)
	(apply fWm-fun fWm-args)
      ;; Don't know how to tell Emacs to forget any (message ...) and
      ;; redisplay the echo area; using this instead:
      (message ""))))

(put 'funcall-with-message 'lisp-indent-hook 1)



;; This is a lisp version of openp() in src/lread.c.  Instead of using the
;; exec_only argument of openp(), it returns the name of a *readable* file.
;; Should include an optional prefix arg ACCESS as well, but that can't be
;; done correctly in Elisp.
;; FSF:  *Please* move this function to src/lread.c.  It could simply call
;; openp() if exec_only was the mode-arg to access() and not just a boolean
;; flag.  Or openp() and Fwhere_is_file() could both call an extended_openp().
(defun where-is-file (path file &optional suffixes)
  "Search through PATH (list) for a readable FILENAME, expanded by one of the
optional SUFFIXES (string of suffixes separated by \":\"s).  Interactively,
SUFFIXES (default \".elc:.el:\") is prompted when there is a prefix arg."
  (interactive
   (list (let ((path (read-minibuffer "Search path: " "load-path")))
	   (if (and (consp path) (or (stringp (car path)) (null (car path))))
	       path
	     (eval path)))
	 (read-string "Locate file: ")
	 (if current-prefix-arg
	     (read-string "Suffixes: " ".elc:.el:")
	   ".elc:.el:")))
  (if (not (equal file ""))
      (let ((filelist nil) pos temp templist)
	;; Make list of possible file names
	(setq filelist
	      (if suffixes
		  (progn
		    (while (setq pos (string-match ":[^:]*$" suffixes))
		      (setq filelist (cons (concat file (substring suffixes
								   (1+ pos)))
					   filelist))
		      (setq suffixes (substring suffixes 0 pos)))
		    (cons (concat file suffixes) filelist))
		(list file)))
	;; Search PATH for a readable file in filelist
	(catch 'bar
	  (if (file-name-absolute-p file) (setq path '(nil)))
	  (while path
	    (setq templist filelist)
	    (while (progn
		     (cond ((file-readable-p (setq temp (expand-file-name
							 (car templist)
							 (car path))))
			    (if (interactive-p)
				(message "%s" temp))
			    (throw 'bar temp)))
		     (setq templist (cdr templist))))
	    (setq path (cdr path)))
	  (if (interactive-p)
	      (message "(File %s not found)" file))
	  nil))))


(provide 'load-lib-comp)
